using System.Reflection;

namespace Encompass.Engines
{
    internal class ComponentMessageEmitter<TComponent> : Engine where TComponent : struct, IComponent
    {
        public ComponentMessageEmitter() : base()
        {
            var writesAttribute = GetType().GetCustomAttribute<Sends>(false);
            if (writesAttribute != null)
            {
                writesAttribute.sendTypes.Add(typeof(ComponentMessage<TComponent>));
            }

            sendTypes.Add(typeof(ComponentMessage<TComponent>));
        }

        public override void Update(double dt)
        {
            foreach (var (entity, componentID, component) in ReadComponentsFromWorld<TComponent>())
            {
                ComponentMessage<TComponent> componentMessage;
                componentMessage.entity = entity;
                componentMessage.componentID = componentID;
                componentMessage.component = component;
                SendMessage(componentMessage);
            }
        }
    }
}